Index: /palm/trunk/SOURCE/microphysics.f90
===================================================================
--- /palm/trunk/SOURCE/microphysics.f90	(revision 1114)
+++ /palm/trunk/SOURCE/microphysics.f90	(revision 1115)
@@ -757,14 +828,20 @@
 !--       It is not allowed to sediment more rain water content than available
           flux = MIN( flux,                                                   &
-                      hyrho(k) * dzu(k) * qr(k,j,i) + sed_qr(k+1) * dt_sedi )
-
-          sed_qr(k)      = flux / dt_sedi
-          tend_qr(k,j,i) = tend_qr(k,j,i) + ( sed_qr(k+1) - sed_qr(k) ) *     &
-                                            ddzu(k+1) / hyrho(k)
+                      hyrho(k) * dzu(k) * qr_1d(k) + sed_qr(k+1) * dt_micro )
+
+          sed_qr(k) = flux / dt_micro
+
+          qr_1d(k) = qr_1d(k) + ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) / &
+                                hyrho(k) * dt_micro
+          q_1d(k)  = q_1d(k)  + ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) / &
+                                hyrho(k) * dt_micro 
+          pt_1d(k) = pt_1d(k) - ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) / &
+                                hyrho(k) * l_d_cp * pt_d_t(k) * dt_micro
 !
 !--       Compute the rain rate
           prr(k,j,i) = prr(k,j,i) + sed_qr(k) / hyrho(k) *                    &
-                       weight_substep(intermediate_timestep_count) 
-       ENDDO
+                       weight_substep(intermediate_timestep_count)
+       ENDDO
+
 !
 !--    Precipitation amount
@@ -774,6 +851,6 @@
 
           precipitation_amount(j,i) = precipitation_amount(j,i) +   &
-                                      prr(nzb_2d(j,i)+1,j,i) *      &
-                                      hyrho(nzb_2d(j,i)+1) * dt_3d
+                                      prr(nzb_s_inner(j,i)+1,j,i) *      &
+                                      hyrho(nzb_s_inner(j,i)+1) * dt_3d
        ENDIF
 
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 1114)
+++ /palm/trunk/SOURCE/modules.f90	(revision 1115)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! unused variables removed
 !
 ! Former revisions:
@@ -408,7 +408,7 @@
           c_u_m, c_u_m_l, c_v_m, c_v_m_l, c_w_m, c_w_m_l, ddzu, ddzu_pres,     &
           dd2zu, dzu, ddzw, dzw, hyp, inflow_damping_factor, lad, l_grid,      &
-          nr_init, ptdf_x, ptdf_y, pt_init, q_init, qr_init, rdf, rdf_sc,      &
-          sa_init, ug, u_init, u_nzb_p1_for_vfc, vg, v_init, v_nzb_p1_for_vfc, &
-          w_subs, zu, zw
+          nc_1d, nr_1d, ptdf_x, ptdf_y, pt_1d, pt_init, q_1d, q_init, qc_1d,   &
+          qr_1d, rdf, rdf_sc, sa_init, ug, u_init, u_nzb_p1_for_vfc, vg,       &
+          v_init, v_nzb_p1_for_vfc, w_subs, zu, zw
 
     REAL, DIMENSION(:,:), ALLOCATABLE ::                                       &
@@ -430,21 +430,20 @@
           tend_nr, tend_q, tend_qr, tric, u_m_l, u_m_n, u_m_r, u_m_s, v_m_l,   &
           v_m_n, v_m_r, v_m_s, w_m_l, w_m_n, w_m_r, w_m_s
-            
 
 #if defined( __nopointer )
     REAL, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                             &
-          e, e_p, nr, nr_p, p, prho, pt, pt_p, q, q_p, ql, ql_c, ql_v, ql_vp,  &
-          qr, qr_p, rho, sa, sa_p, te_m, tnr_m, tpt_m, tq_m, tqr_m, tsa_m,     &
-          tu_m, tv_m, tw_m, u, u_p, v, v_p, vpt, w, w_p
+          e, e_p, nr, nr_p, p, prho, pt, pt_p, q, q_p, qc, ql, ql_c, ql_v,     &
+          ql_vp, qr, qr_p, rho, sa, sa_p, te_m, tnr_m, tpt_m, tq_m, tqr_m,     &
+          tsa_m, tu_m, tv_m, tw_m, u, u_p, v, v_p, vpt, w, w_p
 #else
     REAL, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                             &
           e_1, e_2, e_3, p, prho_1, nr_1, nr_2, nr_3, pt_1, pt_2, pt_3, q_1,   &
-          q_2, q_3, ql_v, ql_vp, ql_1, ql_2, qr_1, qr_2, qr_3, rho_1, sa_1,    &
-          sa_2, sa_3, u_1, u_2, u_3, v_1, v_2, v_3, vpt_1, w_1, w_2, w_3
+          q_2, q_3, qc_1, ql_v, ql_vp, ql_1, ql_2, qr_1, qr_2, qr_3, rho_1,    &
+          sa_1, sa_2, sa_3, u_1, u_2, u_3, v_1, v_2, v_3, vpt_1, w_1, w_2, w_3
 
     REAL, DIMENSION(:,:,:), POINTER ::                                         &
-          e, e_p, nr, nr_p, prho, pt, pt_p, q, q_p, ql, ql_c, qr, qr_p, rho,   &
-          sa, sa_p, te_m, tnr_m, tpt_m, tq_m, tqr_m, tsa_m, tu_m, tv_m, tw_m,  &
-          u, u_p, v, v_p, vpt, w, w_p
+          e, e_p, nr, nr_p, prho, pt, pt_p, q, q_p, qc, ql, ql_c, qr, qr_p,    &
+          rho, sa, sa_p, te_m, tnr_m, tpt_m, tq_m, tqr_m, tsa_m, tu_m, tv_m,   &
+          tw_m, u, u_p, v, v_p, vpt, w, w_p
 #endif
 
@@ -474,7 +473,7 @@
 
     REAL, DIMENSION(:,:,:), ALLOCATABLE, TARGET :: &
-          e_av, lpt_av, nr_av, p_av, pc_av, pr_av, prr_av, pt_av, q_av, ql_av, &
-          ql_c_av, ql_v_av, ql_vp_av, qr_av, qv_av, rho_av, s_av, sa_av, u_av, &
-          v_av, vpt_av, w_av
+          e_av, lpt_av, nr_av, p_av, pc_av, pr_av, prr_av, pt_av, q_av, qc_av, &
+          ql_av, ql_c_av, ql_v_av, ql_vp_av, qr_av, qv_av, rho_av, s_av, sa_av,&
+          u_av, v_av, vpt_av, w_av
   
  END MODULE averaging
@@ -525,8 +524,9 @@
              eps_ros = 1.0E-4,  & ! accuracy of Rosenbrock method
              eps_sb = 1.0E-20,  & ! threshold in two-moments scheme
-             k_cc = 9.44E09,    & ! const. rain-rain kernel (m3 kg-2 s-1) 
+             k_cc = 9.44E09,    & ! const. cloud-cloud kernel (m3 kg-2 s-1) 
              k_cr0 = 4.33,      & ! const. cloud-rain kernel (m3 kg-1 s-1) 
              k_rr = 7.12,       & ! const. rain-rain kernel (m3 kg-1 s-1) 
              k_br = 1000.,      & ! const. in breakup parametrization (m-1)
+             k_st = 1.2E8,      & ! const. in drizzle parametrization (m-1 s-1)
              kappa_rr = 60.7,   & ! const. in collision kernel (kg-1/3)
              kin_vis_air = 1.4086E-5, & ! kin. viscosity of air (m2 s-1)
@@ -536,5 +536,5 @@
              molecular_weight_of_solute = 0.05844, & ! mol. m. NaCl (kg mol-1)
              molecular_weight_of_water = 0.01801528, & ! mol. m. H2O (kg mol-1)
-             nc = 70.0E6,       & ! cloud droplet concentration 
+             nc_const = 70.0E6, & ! cloud droplet concentration
              prec_time_const = 0.001, & !coef. in Kessler scheme
              pirho_l, dpirho_l, & ! pi * rho_l / 6.0; 6.0 / ( pi * rho_l )
@@ -545,4 +545,5 @@
              schmidt = 0.71,    & ! Schmidt number
              schmidt_p_1d3,     & ! schmidt**( 1.0 / 3.0 )
+             sigma_gc = 1.3,    & ! log-normal geometric standard deviation
              stp = 2.5066282746310005, & ! parameter in gamma function
              thermal_conductivity_l = 2.43E-2, & ! therm. cond. air (J m-1 s-1 K-1)
@@ -554,6 +555,5 @@
              w_precipitation = 9.65      ! maximum terminal velocity (m s-1)
 
-    REAL, DIMENSION(:), ALLOCATABLE     ::  dr, hyrho, lambda_r, mu_r, pt_d_t, &
-                                            sed_nr, sed_q, sed_qr, t_d_pt, xr  
+    REAL, DIMENSION(:), ALLOCATABLE     ::  hyrho, pt_d_t, t_d_pt  
 
     REAL, DIMENSION(:,:), ALLOCATABLE   ::  precipitation_amount, &
@@ -630,10 +630,8 @@
                              scalar_advec = 'ws-scheme'
     CHARACTER (LEN=20)   ::  bc_e_b = 'neumann', bc_lr = 'cyclic', &
-                             bc_nr_b = 'neumann', bc_nr_t = 'neumann', &
                              bc_ns = 'cyclic', bc_p_b = 'neumann', &
                              bc_p_t = 'dirichlet', bc_pt_b = 'dirichlet', &
                              bc_pt_t = 'initial_gradient', &
                              bc_q_b = 'dirichlet', bc_q_t = 'neumann', &
-                             bc_qr_b = 'neumann', bc_qr_t = 'neumann',&
                              bc_s_b = 'dirichlet', bc_s_t = 'neumann', &
                              bc_sa_t = 'neumann', &
@@ -681,6 +679,6 @@
                 dp_level_ind_b = 0, dvrp_filecount = 0, &
                 dz_stretch_level_index, gamma_mg, gathered_size, &
-                grid_level, ibc_e_b, ibc_nr_b, ibc_nr_t, ibc_p_b, ibc_p_t, &
-                ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, ibc_qr_b, ibc_qr_t, &
+                grid_level, ibc_e_b, ibc_p_b, ibc_p_t, &
+                ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, &
                 ibc_sa_t, ibc_uv_b, ibc_uv_t, icloud_scheme, &
                 inflow_disturbance_begin = -1, inflow_disturbance_end = -1, &
@@ -705,8 +703,6 @@
                 mask_size(max_masks,3) = -1, mask_size_l(max_masks,3) = -1, &
                 mask_start_l(max_masks,3) = -1, &
-                nr_vertical_gradient_level_ind(10) = -9999, &
                 pt_vertical_gradient_level_ind(10) = -9999, &
                 q_vertical_gradient_level_ind(10) = -9999, &
-                qr_vertical_gradient_level_ind(10) = -9999, &
                 sa_vertical_gradient_level_ind(10) = -9999, &
                 section(100,3), section_xy(100) = -9999, &
@@ -738,6 +734,5 @@
                 constant_top_momentumflux = .FALSE., &
                 constant_top_salinityflux = .TRUE., &
-                constant_waterflux = .TRUE., constant_waterflux_nr = .TRUE., &
-                constant_waterflux_qr = .TRUE., create_disturbances = .TRUE., &
+                constant_waterflux = .TRUE., create_disturbances = .TRUE., &
                 data_output_2d_on_each_pe = .TRUE., & 
                 dissipation_control = .FALSE., disturbance_created = .FALSE., &
@@ -779,5 +774,5 @@
              averaging_interval = 0.0, averaging_interval_pr = 9999999.9, &
              averaging_interval_sp = 9999999.9, bc_pt_t_val, bc_q_t_val, &
-             bc_qr_t_val, bc_nr_t_val, bottom_salinityflux = 0.0, &
+             bottom_salinityflux = 0.0, &
              building_height = 50.0, building_length_x = 50.0, &
              building_length_y = 50.0, building_wall_left = 9999999.9, &
@@ -799,5 +794,5 @@
              dt_do2d_xy = 9999999.9, dt_do2d_xz = 9999999.9, &
              dt_do2d_yz = 9999999.9, dt_do3d = 9999999.9, dt_dvrp = 9999999.9, &
-             dt_max = 20.0, dt_restart = 9999999.9, &
+             dt_max = 20.0, dt_micro = -1.0, dt_restart = 9999999.9, &
              dt_run_control = 60.0, dt_3d = -1.0, dz = -1.0, &
              dz_max = 9999999.9, dz_stretch_factor = 1.08, &
@@ -810,5 +805,4 @@
              maximum_cpu_time_allowed = 0.0,  &
              molecular_viscosity = 1.461E-5, &
-             nr_surface = 0.0, nr_surface_initial_change = 0.0, &
              old_dt = 1.0E-10, omega = 7.29212E-5, omega_sor = 1.8, &
              particle_maximum_age = 9999999.9, &
@@ -819,5 +813,4 @@
              pt_surface = 300.0, pt_surface_initial_change = 0.0, &
              q_surface = 0.0, q_surface_initial_change = 0.0, &
-             qr_surface = 0.0, qr_surface_initial_change = 0.0, &
              rayleigh_damping_factor = -1.0, rayleigh_damping_height = -1.0, &
              recycling_width = 9999999.9, residual_limit = 1.0E-4, &
@@ -832,5 +825,4 @@
              surface_heatflux = 9999999.9, surface_pressure = 1013.25, &
              surface_scalarflux = 9999999.9, surface_waterflux = 9999999.9, &
-             surface_waterflux_nr = 0.0, surface_waterflux_qr = 0.0, &
              s_surface = 0.0, s_surface_initial_change = 0.0, &
              termination_time_needed = -1.0, time_coupling = 0.0, &
@@ -854,12 +846,8 @@
              lad_vertical_gradient_level(10) = -9999999.9, &
              mask_scale(3), &
-             nr_vertical_gradient(10) = 0.0, &
-             nr_vertical_gradient_level(10) = -1.0, &
              pt_vertical_gradient(10) = 0.0, &
              pt_vertical_gradient_level(10) = -9999999.9, &
              q_vertical_gradient(10) = 0.0, &
              q_vertical_gradient_level(10) = -1.0, &
-             qr_vertical_gradient(10) = 0.0, &
-             qr_vertical_gradient_level(10) = -1.0, &
              s_vertical_gradient(10) = 0.0, &
              s_vertical_gradient_level(10) = -1.0, &
@@ -877,5 +865,5 @@
              volume_flow(1:2) = 0.0, volume_flow_area(1:2) = 0.0, &
              volume_flow_initial(1:2) = 0.0, wall_heatflux(0:4) = 0.0, &
-             wall_humidityflux(0:4) = 0.0, wall_nrflux(0:4) = 0.0, & 
+             wall_humidityflux(0:4) = 0.0, wall_nrflux(0:4) = 0.0, &
              wall_qflux(0:4) = 0.0, wall_qrflux(0:4) = 0.0, &
              wall_salinityflux(0:4) = 0.0, wall_scalarflux(0:4) = 0.0, &
Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 1114)
+++ /palm/trunk/SOURCE/parin.f90	(revision 1115)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! unused variables removed
 !
 ! Former revisions:
@@ -224,7 +224,6 @@
              loop_optimization, masking_method, mg_cycles, &
              mg_switch_to_pe0_level, mixing_length_1d, momentum_advec, &
-             nc, netcdf_precision, neutral, ngsrb, nr_surface, &
-             nr_surface_initial_change, nr_vertical_gradient, &
-             nr_vertical_gradient_level, nsor, &
+             nc_const, netcdf_precision, neutral, ngsrb, &
+             nsor, &
              nsor_ini, nx, ny, nz, ocean, omega, omega_sor, &
              passive_scalar, pch_index, phi, plant_canopy, prandtl_layer, &
@@ -234,6 +233,5 @@
              pt_vertical_gradient_level, q_surface, q_surface_initial_change, &
              q_vertical_gradient, q_vertical_gradient_level, &
-             qr_surface, qr_surface_initial_change, &
-             qr_vertical_gradient, qr_vertical_gradient_level, radiation, &
+             radiation, &
              random_generator, random_heatflux, rayleigh_damping_factor, &
              rayleigh_damping_height, recycling_width, residual_limit, &
@@ -243,6 +241,6 @@
              statistic_regions, subs_vertical_gradient, &
              subs_vertical_gradient_level, surface_heatflux, surface_pressure, &
-             surface_scalarflux, surface_waterflux, surface_waterflux_nr, &
-             surface_waterflux_qr, s_surface, &
+             surface_scalarflux, surface_waterflux, &
+             s_surface, &
              s_surface_initial_change, s_vertical_gradient, &
              s_vertical_gradient_level, timestep_scheme, &
@@ -412,5 +410,4 @@
 !--                  also check the allocate statement in routine read_var_list
              ALLOCATE( lad(0:nz+1),pt_init(0:nz+1), q_init(0:nz+1),           &
-                       qr_init(0:nz+1), nr_init(0:nz+1),                      &
                        sa_init(0:nz+1), ug(0:nz+1), u_init(0:nz+1),           &
                        v_init(0:nz+1), vg(0:nz+1),                            &
Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 1114)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 1115)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! optimized cloud physics: calculation of microphysical tendencies transfered 
+! to microphysics.f90; qr and nr are only calculated if precipitation is required
 !
 ! Former revisions:
@@ -229,5 +230,4 @@
     IF ( ( ws_scheme_mom .OR. ws_scheme_sca )  .AND.  &
          intermediate_timestep_count == 1 )  CALL ws_statistics
-
 !
 !-- Loop over all prognostic equations
@@ -285,5 +285,4 @@
 
              CALL user_actions( i, j, 'u-tendency' )
-
 !
 !--          Prognostic equation for u-velocity component
@@ -341,5 +340,4 @@
 
              CALL user_actions( i, j, 'v-tendency' )
-
 !
 !--          Prognostic equation for v-velocity component
@@ -422,31 +420,8 @@
              ENDIF
           ENDIF
-
-!
-!--       If required, calculate tendencies for total water content, rain water 
-!--       content, rain drop concentration and liquid temperature
-          IF ( cloud_physics  .AND.  icloud_scheme == 0 )  THEN
-
-             tend_q(:,j,i)  = 0.0
-             tend_qr(:,j,i) = 0.0
-             tend_nr(:,j,i) = 0.0
-             tend_pt(:,j,i) = 0.0
-!
-!--          Droplet size distribution (dsd) properties are needed for the
-!--          computation of selfcollection, breakup, evaporation and
-!--          sedimentation of rain
-             IF ( precipitation )  THEN
-                CALL dsd_properties( i,j )
-                CALL autoconversion( i,j )
-                CALL accretion( i,j )
-                CALL selfcollection_breakup( i,j )
-                CALL evaporation_rain( i,j )
-                CALL sedimentation_rain( i,j )
-             ENDIF
-
-             IF ( drizzle )  CALL sedimentation_cloud( i,j )
-
-          ENDIF
-
+!
+!--       If required, calculate tendencies for total water content, liquid water 
+!--       potential temperature, rain water content and rain drop concentration
+          IF ( cloud_physics  .AND.  icloud_scheme == 0 )  CALL microphysics_control( i, j )
 !
 !--       If required, compute prognostic equation for potential temperature
@@ -650,5 +625,6 @@
 !--          If required, calculate prognostic equations for rain water content 
 !--          and rain drop concentration
-             IF ( cloud_physics  .AND.  icloud_scheme == 0 )  THEN
+             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
+                  precipitation )  THEN
 !
 !--             Calculate prognostic equation for rain water content
@@ -667,5 +643,4 @@
                 ENDIF
                 CALL diffusion_s( i, j, qr, qrsws, qrswst, wall_qrflux )
-
 !
 !--             Using microphysical tendencies (autoconversion, accretion, 
@@ -673,20 +648,12 @@
                 tend(:,j,i) = tend(:,j,i) + tend_qr(:,j,i)
 
-!
-!--             If required, compute influence of large-scale subsidence/ascent
-                IF ( large_scale_subsidence )  THEN
-                   CALL subsidence( i, j, tend, qr, qr_init )
-                ENDIF
-
-!              CALL user_actions( i, j, 'qr-tendency' )
-
+                CALL user_actions( i, j, 'qr-tendency' )
 !
 !--             Prognostic equation for rain water content
                 DO  k = nzb_s_inner(j,i)+1, nzt
-                   qr_p(k,j,i) = qr(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +    &
-                                                     tsc(3) * tqr_m(k,j,i) )     &
-                                         - tsc(5) * rdf_sc(k) *                  &
-                                        ( qr(k,j,i) - qr_init(k) )
-                   IF ( qr_p(k,j,i) < 0.0 )  qr_p(k,j,i) = 0.1 * qr(k,j,i)
+                   qr_p(k,j,i) = qr(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +  &
+                                                       tsc(3) * tqr_m(k,j,i) ) &
+                                           - tsc(5) * rdf_sc(k) * qr(k,j,i)
+                   IF ( qr_p(k,j,i) < 0.0 )  qr_p(k,j,i) = 0.0
                 ENDDO
 !
@@ -711,7 +678,7 @@
                 IF ( timestep_scheme(1:5) == 'runge' )  THEN
                    IF ( ws_scheme_sca )  THEN
-                      CALL advec_s_ws( i, j, nr, 'nr', flux_s_nr,       & 
-                                       diss_s_nr, flux_l_nr, diss_l_nr, &
-                                       i_omp_start, tn )
+                      CALL advec_s_ws( i, j, nr, 'nr', flux_s_nr,    & 
+                                    diss_s_nr, flux_l_nr, diss_l_nr, &
+                                    i_omp_start, tn )
                    ELSE 
                       CALL advec_s_pw( i, j, nr )
@@ -721,5 +688,5 @@
                 ENDIF
                 CALL diffusion_s( i, j, nr, nrsws, nrswst, wall_nrflux )
-
+!
 !--             Using microphysical tendencies (autoconversion, accretion, 
 !--             selfcollection, breakup, evaporation; 
@@ -727,20 +694,12 @@
                 tend(:,j,i) = tend(:,j,i) + tend_nr(:,j,i)
 
-!
-!--             If required, compute influence of large-scale subsidence/ascent
-                IF ( large_scale_subsidence )  THEN
-                   CALL subsidence( i, j, tend, nr, nr_init )
-                ENDIF
-
-!                CALL user_actions( i, j, 'nr-tendency' )
-
+                CALL user_actions( i, j, 'nr-tendency' )
 !
 !--             Prognostic equation for rain drop concentration
                 DO  k = nzb_s_inner(j,i)+1, nzt
-                   nr_p(k,j,i) = nr(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) + &
-                                                  tsc(3) * tnr_m(k,j,i) )     &
-                                      - tsc(5) * rdf_sc(k) *                  &
-                                        ( nr(k,j,i) - nr_init(k) )
-                   IF ( nr_p(k,j,i) < 0.0 )  nr_p(k,j,i) = 0.1 * nr(k,j,i)
+                   nr_p(k,j,i) = nr(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +  &
+                                                       tsc(3) * tnr_m(k,j,i) ) &
+                                           - tsc(5) * rdf_sc(k) * nr(k,j,i)
+                   IF ( nr_p(k,j,i) < 0.0 )  nr_p(k,j,i) = 0.0
                 ENDDO
 !
@@ -762,6 +721,5 @@
              ENDIF
 
-          ENDIF
-
+         ENDIF
 !
 !--       If required, compute prognostic equation for turbulent kinetic 
Index: /palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- /palm/trunk/SOURCE/read_3d_binary.f90	(revision 1114)
+++ /palm/trunk/SOURCE/read_3d_binary.f90	(revision 1115)
@@ -20,4 +20,5 @@
 ! Current revisions:
 ! -----------------
+! unused variables removed
 !
 ! Former revisions:
@@ -283,5 +284,5 @@
 !--    First compare the version numbers
        READ ( 13 )  version_on_file
-       binary_version = '3.3'
+       binary_version = '3.4'
        IF ( TRIM( version_on_file ) /= TRIM( binary_version ) )  THEN
           WRITE( message_string, * ) 'version mismatch concerning data ',      &
@@ -432,4 +433,32 @@
                                   tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
+                CASE ( 'nr' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   nr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'nr_av' )
+                   IF ( .NOT. ALLOCATED( nr_av ) )  THEN
+                      ALLOCATE( nr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   nr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                    tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'nrs' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   nrs(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'nrsws' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   nrsws(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'nrswst' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   nrswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
                 CASE ( 'p' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -516,4 +545,17 @@
                                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
+                CASE ( 'qc' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   qc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                       tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'qc_av' )
+                   IF ( .NOT. ALLOCATED( qc_av ) )  THEN
+                      ALLOCATE( qc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_3d
+                   qc_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                                       tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
                 CASE ( 'ql' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -534,9 +576,4 @@
                                    tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
-                CASE ( 'nr' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   nr(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
-                                   tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'qr_av' )
                    IF ( .NOT. ALLOCATED( qr_av ) )  THEN
@@ -547,12 +584,4 @@
                                     tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
-                CASE ( 'nr_av' )
-                   IF ( .NOT. ALLOCATED( nr_av ) )  THEN
-                      ALLOCATE( nr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   nr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
-                                    tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'qrs' )
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
@@ -568,19 +597,4 @@
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
                    qrswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'nrs' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   nrs(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'nrsws' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   nrsws(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
-                                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'nrswst' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   nrswst(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
                                           tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
Index: /palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- /palm/trunk/SOURCE/read_var_list.f90	(revision 1114)
+++ /palm/trunk/SOURCE/read_var_list.f90	(revision 1115)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! unused variables removed
 !
 ! Former revisions:
@@ -185,5 +185,5 @@
 !-- Make version number check first
     READ ( 13 )  version_on_file
-    binary_version = '3.8'
+    binary_version = '3.9'
     IF ( TRIM( version_on_file ) /= TRIM( binary_version ) )  THEN
        WRITE( message_string, * ) 'version mismatch concerning control ', &
@@ -251,5 +251,5 @@
        ALLOCATE( lad(0:nz+1), ug(0:nz+1), u_init(0:nz+1), vg(0:nz+1),    &
                  v_init(0:nz+1), pt_init(0:nz+1), q_init(0:nz+1),        &
-                 qr_init(0:nz+1), nr_init(0:nz+1), sa_init(0:nz+1),      &
+                 sa_init(0:nz+1),                                        &
                  hom(0:nz+1,2,pr_palm+max_pr_user,0:statistic_regions),  &
                  hom_sum(0:nz+1,pr_palm+max_pr_user,0:statistic_regions) )
@@ -284,10 +284,4 @@
           CASE ( 'bc_ns' )
              READ ( 13 )  bc_ns
-          CASE ( 'bc_nr_b' )
-             READ ( 13 )  bc_nr_b
-          CASE ( 'bc_nr_t' )
-             READ ( 13 )  bc_nr_t
-          CASE ( 'bc_nr_t_val' )
-             READ ( 13 )  bc_nr_t_val
           CASE ( 'bc_p_b' )
              READ ( 13 )  bc_p_b
@@ -306,10 +300,4 @@
           CASE ( 'bc_q_t_val' )
              READ ( 13 )  bc_q_t_val
-          CASE ( 'bc_qr_b' )
-             READ ( 13 )  bc_qr_b
-          CASE ( 'bc_qr_t' )
-             READ ( 13 )  bc_qr_t
-          CASE ( 'bc_qr_t_val' )
-             READ ( 13 )  bc_qr_t_val
           CASE ( 'bc_s_b' )
              READ ( 13 )  bc_s_b
@@ -474,6 +462,6 @@
           CASE ( 'momentum_advec' )
              READ ( 13 )  momentum_advec
-          CASE ( 'nc' )
-             READ ( 13 )  nc
+          CASE ( 'nc_const' )
+             READ ( 13 )  nc_const
           CASE ( 'netcdf_precision' )
              READ ( 13 )  netcdf_precision
@@ -482,16 +470,4 @@
           CASE ( 'ngsrb' )
              READ ( 13 )  ngsrb
-          CASE ( 'nr_init' )
-             READ ( 13 )  nr_init
-          CASE ( 'nr_surface' )
-             READ ( 13 )  nr_surface
-          CASE ( 'nr_surface_initial_change' )
-             READ ( 13 )  nr_surface_initial_change
-          CASE ( 'nr_vertical_gradient' )
-             READ ( 13 )  nr_vertical_gradient
-          CASE ( 'nr_vertical_gradient_level' )
-             READ ( 13 )  nr_vertical_gradient_level
-          CASE ( 'nr_vertical_gradient_level_ind' )
-             READ ( 13 )  nr_vertical_gradient_level_ind
           CASE ( 'nsor' )
              READ ( 13 )  nsor
@@ -560,16 +536,4 @@
           CASE ( 'q_vertical_gradient_level_ind' )
              READ ( 13 )  q_vertical_gradient_level_ind
-          CASE ( 'qr_init' )
-             READ ( 13 )  qr_init
-          CASE ( 'qr_surface' )
-             READ ( 13 )  qr_surface
-          CASE ( 'qr_surface_initial_change' )
-             READ ( 13 )  qr_surface_initial_change
-          CASE ( 'qr_vertical_gradient' )
-             READ ( 13 )  qr_vertical_gradient
-          CASE ( 'qr_vertical_gradient_level' )
-             READ ( 13 )  qr_vertical_gradient_level
-          CASE ( 'qr_vertical_gradient_level_ind' )
-             READ ( 13 )  qr_vertical_gradient_level_ind
           CASE ( 'radiation' )
              READ ( 13 )  radiation
@@ -618,8 +582,4 @@
           CASE ( 'surface_waterflux' )
              READ ( 13 )  surface_waterflux      
-          CASE ( 'surface_waterflux_nr' )
-             READ ( 13 )  surface_waterflux_nr    
-          CASE ( 'surface_waterflux_qr' )
-             READ ( 13 )  surface_waterflux_qr    
           CASE ( 's_surface' )
              READ ( 13 )  s_surface
Index: /palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1114)
+++ /palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1115)
@@ -20,4 +20,5 @@
 ! Current revisions:
 ! -----------------
+! ql is calculated by calc_liquid_water_content
 !
 ! Former revisions:
@@ -164,4 +165,10 @@
                 ENDIF
                 q_av = 0.0
+
+             CASE ( 'qc' )
+                IF ( .NOT. ALLOCATED( qc_av ) )  THEN
+                   ALLOCATE( qc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                qc_av = 0.0
 
              CASE ( 'ql' )
@@ -411,4 +418,13 @@
              ENDDO
 
+          CASE ( 'qc' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   DO  k = nzb, nzt+1
+                      qc_av(k,j,i) = qc_av(k,j,i) + qc(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+
           CASE ( 'ql' )
              DO  i = nxlg, nxrg
